#!/usr/bin/env bash
###################################################
# Generated by render-templates.ts, DO NOT MODIFY #
###################################################

set -e -u -o pipefail
shopt -s inherit_errexit

IIDFILE_0="$(mktemp)"
${DOCKER_CMD:-docker} image build \
  --iidfile "${IIDFILE_0:?}" \
  --target "slim" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:dev-slim" \
  .

IIDFILE_1="$(mktemp)"
${DOCKER_CMD:-docker} image build \
  --iidfile "${IIDFILE_1:?}" \
  --target "full" \
  --tag "registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:dev" \
  .

# We emit a JSON object on stdout containing event data describing the build
# that has occured. This event may be persisted to the project's event log to
# allow future operations to operate on this information.
IMAGE_ID_0="$(cat "${IIDFILE_0:?}")"
BUILT_IMAGE_JSON_0="$(jq \
  --null-input \
  --arg dockerfile Dockerfile \
  --arg target "slim" \
  --arg id "${IMAGE_ID_0:?}" \
  --argjson repoTags '["registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:dev-slim"]' \
  '{ dockerfile: $dockerfile, target: $target, id: $id, repoTags: $repoTags }' \
)"
IMAGE_ID_1="$(cat "${IIDFILE_1:?}")"
BUILT_IMAGE_JSON_1="$(jq \
  --null-input \
  --arg dockerfile Dockerfile \
  --arg target "full" \
  --arg id "${IMAGE_ID_1:?}" \
  --argjson repoTags '["registry.gitlab.developers.cam.ac.uk/lib/dev/common/docker-compose-pipelines:dev"]' \
  '{ dockerfile: $dockerfile, target: $target, id: $id, repoTags: $repoTags }' \
)"


# The built image objects are passed to jq on stdin as a stream. We need --seq
# to make jq produce application/json-seq, but this also makes jq expect
# application/json-seq on input, so we must encode the input accordingly by
# starting JSON objects with ASCII record separator (\x1e) and ending with a
# newline.
BUILT_IMAGES_JSON="$(printf '\x1e%s\n' "${BUILT_IMAGE_JSON_0:?}" "${BUILT_IMAGE_JSON_1:?}")"
DATE="$(date --rfc-3339=seconds --utc)"
<<<"${BUILT_IMAGES_JSON:?}" \
jq --null-input --seq \
  --arg date "${DATE:?}" \
  --arg event DevImagesBuilt \
  --argjson releaseGitTag null \
  --argjson releaseGitCommit null \
  '[inputs] as $builtImages | {
    event: $event,
    date: $date,
    releaseGitTag: $releaseGitTag,
    releaseGitCommit: $releaseGitCommit,
    images: $builtImages
  } | del(.[] | select(. == null))' \
  || exit 1
